/* pam_end.c */

#include <stdlib.h>

#include "pam_appl.h"
#include "pam_private.h"

#define FREE(x) { if (x) free(x); }

int pam_end(pam_handle_t *pamh, int pam_status)
{
    FREE(pamh->service_name);
    FREE(pamh->user);
    FREE(pamh->tty);
    FREE(pamh->rhost);
    FREE(pamh->ruser);
    FREE(pamh->authtok);
    FREE(pamh->oldauthtok);

    _pam_free_data(pamh, pam_status);
    _pam_free_handlers(pamh);

    free(pamh);
    
    return PAM_SUCCESS;
}
