/* pam_misc.c -- This is random stuff */

#include <stdarg.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <syslog.h>

#include "pam_private.h"

char *strdup(const char *s)
{
    char *p = malloc(strlen(s) + 1);
    strcpy(p, s);
    return p;
}

/* Generate argv, argc from s */
/* caller must free(argv)     */

int pam_mkargv(char *s, char ***argv, int *argc)
{
    int l;
    int argvlen = 0;
    char *sbuf, *sbuf_start;
    char **our_argv = NULL;
    char **argvbuf;
    char *argvbufp;

    *argc = 0;

    l = strlen(s);
    if (l) {
	sbuf = sbuf_start = strdup(s);
	/* Overkill on the malloc, but not large */
	argvlen = l * ((sizeof(char)) + sizeof(char *));
	our_argv = argvbuf = malloc(argvlen);
	argvbufp = (char *) argvbuf + (l * sizeof(char *));
	while ((sbuf = strtok(sbuf, " \n\t"))) {
	    strcpy(argvbufp, sbuf);
	    *argvbuf = argvbufp;
	    argvbufp += strlen(argvbufp) + 1;
	    
	    (*argc)++;
	    argvbuf++;
	    sbuf = NULL;
	}
	free(sbuf_start);
    }

    *argv = our_argv;
    return(argvlen);
}

void _pam_log_error(const char *format, ...)
{
    char buf[1024];
    va_list args;

    va_start(args, format);
    vsprintf(buf, format, args);

#ifdef DEBUG
#define ADDPERROR |LOG_PERROR
#else
#define ADDPERROR
#endif

    openlog("pam", LOG_CONS|LOG_PID ADDPERROR, LOG_AUTH);
    syslog(LOG_CRIT, buf);
    closelog();
}

#ifdef DEBUG
void _pam_debug(const char *format, ...)
{
    va_list args;

    va_start(args, format);

    vfprintf(stderr, format, args);
    fprintf(stderr, "\n");
}
#endif
