/* pam_start.c */

#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include "pam_appl.h"
#include "pam_private.h"

int pam_start (
    char *service_name,
    char *user,
    struct pam_conv *pam_conversation,
    pam_handle_t **pamh)
{
    *pamh = malloc(sizeof(**pamh));

    (*pamh)->service_name = service_name ? strdup(service_name) : NULL;
    (*pamh)->user = user ? strdup(user) : NULL;
    (*pamh)->tty = NULL;
    (*pamh)->ruser = NULL;
    (*pamh)->rhost = NULL;
    (*pamh)->authtok = NULL;
    (*pamh)->oldauthtok = NULL;
    (*pamh)->pam_conversation = pam_conversation;
    (*pamh)->data = NULL;

    _pam_start_handlers(*pamh);

    /* According to the SunOS man pages, loading modules and resolving
     * symbols happens on the first call from the application.
     * _pam_init_handlers(*pamh);
     */
    
    return PAM_SUCCESS;
}
