/* pam_strerror.c */

#include "pam_appl.h"

const char *pam_strerror(int errnum)
{
    switch (errnum) {
    case PAM_SUCCESS:
	return "Success";
    case PAM_ABORT:
	return "Critical Error - Aborted";
    case PAM_OPEN_ERR:
	return "dlopen() failure";
    case PAM_SYMBOL_ERR:
	return "Symbol not found";
    case PAM_SERVICE_ERR:
	return "Error in service module";
    case PAM_SYSTEM_ERR:
	return "System error";
    case PAM_BUF_ERR:
	return "Memory buffer error";
    case PAM_PERM_DENIED:
	return "Permission denied";
    case PAM_AUTH_ERR:
	return "Authentication failure";
    case PAM_CRED_INSUFFICIENT:
	return "Can not access authentication data "
	    "due to insufficient credentials";
    case PAM_AUTHINFO_UNAVAIL:
	return "Underlying authentication service "
	    "can not retrieve authenticaiton "
	    "information";
    case PAM_USER_UNKNOWN:
	return "User not known to the underlying "
	    "authenticaiton module ";
    case PAM_MAXTRIES:
	return "An authentication service has "
	    "maintained a retry count which has "
	    "been reached.  No further retries "
	    "should be attempted";
    case PAM_AUTHTOKEN_REQD:
	return "New authentication token required. "
	    "This is normally returned if the "
	    "machine security policies require "
	    "that the password should be changed "
	    "beccause the password is NULL or it "
	    "has aged";
    case PAM_ACCT_EXPIRED:
	return "User account has expired";
    case PAM_SESSION_ERR:
	return "Can not make/remove an entry for "
	    "the specified session";
    case PAM_CRED_UNAVAIL:
	return "Underlying authentication service "
	    "can not retrieve user credentials "
	    "unavailable";
    case PAM_CRED_EXPIRED:
	return "User credentials expired";
    case PAM_CRED_ERR:
	return "Failure setting user credentials";
    case PAM_NO_MODULE_DATA:
	return "No module specific data is present";
    case PAM_BAD_ITEM:
	return "Bad item passed to pam_*_item()";
    }
    
    return "Unknown PAM error";
}
